VERSION 5.00
Begin VB.Form Frm_Main 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Solitaire State"
   ClientHeight    =   840
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3750
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   840
   ScaleWidth      =   3750
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.PictureBox Pic_Check 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'Kein
      ForeColor       =   &H00000000&
      Height          =   375
      Left            =   1560
      ScaleHeight     =   25
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   25
      TabIndex        =   6
      Top             =   600
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.PictureBox Pic_Out 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'Kein
      Height          =   375
      Left            =   1080
      ScaleHeight     =   25
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   25
      TabIndex        =   5
      Top             =   600
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.CommandButton Cmd_ReadData 
      Caption         =   "Lesen"
      Height          =   615
      Left            =   2400
      TabIndex        =   4
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Lbl_Screen 
      Caption         =   "Zeit:"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   735
   End
   Begin VB.Label Lbl_Screen 
      Caption         =   "Punkte:"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   735
   End
   Begin VB.Label Lbl_Time 
      BorderStyle     =   1  'Fest Einfach
      Height          =   255
      Left            =   960
      TabIndex        =   1
      Top             =   480
      Width           =   1335
   End
   Begin VB.Label Lbl_Score 
      BorderStyle     =   1  'Fest Einfach
      Height          =   255
      Left            =   960
      TabIndex        =   0
      Top             =   120
      Width           =   1335
   End
End
Attribute VB_Name = "Frm_Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wCmd As Long) As Long
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function GetWindowDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Const GW_HWNDFIRST = 0
Private Const GW_HWNDNEXT = 2
Private Const GW_CHILD = 5

Private Const HWND_TOPMOST = -1
Private Const HWND_NOTOPMOST = -2
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOMOVE = &H2

Private Const TitleName As String = "Solitr"

Private Function SolitaireScore(resScore As Long, resTime As Long)
   Dim hWnd_Main As Long, hWnd_Sub As Long
   Dim DC_Sub As Long
   Dim SizeInfo As RECT
   Dim resState() As String
   Dim X As Long, Y As Long
   Dim i As Long

   resScore = -1
   resTime = -1

   'hWnd des Solitr-Fensters ermitteln'
   hWnd_Main = GetSolitaire()

   If hWnd_Main = 0 Then
      MsgBox "Komm, mach doch erstmal Solitr auf!", vbOKOnly + vbExclamation, "Aufgepasst"

   Else
      
      'Das erste Kind von Solitr ist die Status-Leiste'
      hWnd_Sub = GetWindow(hWnd_Main, GW_CHILD)
      
      'Wer Bock hat kann die Leiste ja verschwinden lassen'
      '   ShowWindow hWnd_Sub, 0
      
      'Das ist total witzig'
      '   ShowWindow hWnd_Sub, -1
   
      'Infos der Leiste auslesen'
      Call GetClientRect(hWnd_Sub, SizeInfo)
         
      'ber den DC des hWnd kann die Status-Leiste in eine Picturebox kopiert werden!!'
      DC_Sub = GetWindowDC(hWnd_Sub)
            
      'Solitr in den Vordergrund holen, weil die Status-Leiste kein AutoRedraw hat :('
      SetWindowPos hWnd_Main, HWND_TOPMOST, 0&, 0&, 0&, 0&, SWP_NOSIZE Or SWP_NOMOVE
      SetWindowPos hWnd_Main, HWND_NOTOPMOST, 0&, 0&, 0&, 0&, SWP_NOSIZE Or SWP_NOMOVE
      
      'Status-Leiste kopieren (es geht auch einfacher, bin jetzt spontan nur nicht drauf gekommen)'
      Pic_Out.Cls
      Pic_Out.Width = SizeInfo.Right * Screen.TwipsPerPixelX
      Pic_Out.Height = SizeInfo.Bottom * Screen.TwipsPerPixelY
      For X = 0 To SizeInfo.Right
         For Y = 0 To SizeInfo.Bottom
            Pic_Out.PSet (X, Y - 2), GetPixel(DC_Sub, X, Y)
         Next Y
      Next X
            
      'Status-Bild in Text konvertieren und in ein Array schreiben'
      resState = Split(modPicToText.getTextFromPicture(Pic_Out, Pic_Check), "*")
      
      'Daten aus Array lesen'
      For i = 0 To UBound(resState)
         If resState(i) <> "" And resScore = -1 Then
            resScore = CLng(resState(i))
         ElseIf resState(i) <> "" And resScore <> -1 Then
            resTime = CLng(resState(i))
         End If
      Next i
      
   End If

   'Rckgabewert erstellen'
   If resScore <> -1 And resTime <> -1 Then
      SolitaireScore = True
   Else
      SolitaireScore = False
   End If

End Function

Private Function GetSolitaire() As Long
   Dim hWnd As Long
   Dim curTitle As String
   
   'Einsprung hWnd ermitteln'
   hWnd = GetWindow(Frm_Main.hWnd, GW_HWNDFIRST)
      
   Do
      'Titel des aktuellen hWnd auslesen'
      curTitle = Space$(GetWindowTextLength(hWnd) + 1)
      Call GetWindowText(hWnd, curTitle, Len(curTitle))
      curTitle = Left$(curTitle, Len(curTitle) - 1)
      
      If curTitle = TitleName Then
         'Solitr gefunden, hWnd das Solitr-Fensters'
         GetSolitaire = hWnd
         Exit Do
      End If
      
      'Der nchste bitte'
      hWnd = GetWindow(hWnd, GW_HWNDNEXT)
      
   Loop Until hWnd = 0

End Function

Private Sub Cmd_ReadData_Click()
   Dim curScore As Long, curTime As Long

   'Solitr-Status lesen und ausgeben'
   If SolitaireScore(curScore, curTime) = True Then
      Lbl_Score.Caption = CStr(curScore)
      Lbl_Time.Caption = CStr(curTime)
   End If
   
End Sub

